/** ݒϐ
 */
/*
 * Copyright (c) 2000-2005, 2007 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef	ifmmainH
#define	ifmmainH

#include "ifmmedia.h"
#include <SyncObjs.hpp>

extern void __fastcall getSusieCompatiAppName(TStringList* AppList) ;
extern AnsiString __fastcall getFileTypeExt(const DWORD aFileType) ;
extern HICON __fastcall getIconHandle(const char *aFilename, const DWORD aFileType, DWORD aFlag) ;
extern bool __fastcall matchesExt(const AnsiString &aFilename, char *aExt) ;

enum EIfmmOption
{
	OPTION_MemoryPlay,	// ͎Đ
	OPTION_ReturnErr,		// 킴ƃG[Ԃ
	OPTION_StayOnTop,		// EBhEɑOʂ
	OPTION_NoActive,		// EBhEANeBu
	OPTION_WindowPos,		// EBhEʒuŒ
	OPTION_WindowPosX,	// v[[̈ʒu
	OPTION_WindowPosY,	// v[[̈ʒu
	OPTION_Minimized,		// EBhEŏŋN
	OPTION_PreviewMovie,// vr[
	OPTION_PreviewPos1,	// vr[ʒu
	OPTION_PreviewPos2,	// vr[ʒu
	OPTION_MovieCenter,	// 𒆉ɕ\
	OPTION_MovieSize,		// ̃TCY{
	OPTION_MoviePosX,		// v[[̈ʒu
	OPTION_MoviePosY,		// v[[̈ʒu
	OPTION_MovieHeight,	// ̃JX^TCY
	OPTION_MovieWidth,	// ̃JX^TCY
	OPTION_DebugMode,		// t@C`FbNȂōĐ݂
	OPTION_SusieOnly,		// SusieȊO̎gps
	OPTION_IsSusie,			// ĂяoSusieH
	OPTION_PlayByViX,		// ViXŃvr[݂̂𗘗pIvVBGetPictureŃG[ԂB
	OPTION_IsViX,				// ĂяoViXH
	OPTION_COUNT,
} ;
enum EIfmmPlayType
{
	WAVEPLAY,
	MIDIPLAY,
	AVIPLAY,
	AIFFPLAY,
	MOVPLAY,
	MPEGPLAY,
	MPAPLAY,
	AUPLAY,
	OGGPLAY,
	RMPLAY,
	AGIFPLAY,
	USERPLAY,
//TODO 5 -cΉ`ǉ:ĐID	
} ;
typedef struct
{
	/* IvVݒ */
	DWORD option[ OPTION_COUNT ] ;

	/* T|[g` */
	bool playable[ FILETYPE_COUNT ] ;
} IFMMVAR_STRUCT ;

class TPluginVar
{
public:
	__fastcall TPluginVar()
	{
		m_cs = new TCriticalSection ;
	}
	virtual __fastcall ~TPluginVar()
	{
		delete m_cs ;
	}

	DWORD __fastcall getOption(DWORD id)
	{
		DWORD result;
		enter() ;
		try
		{
			result = m_var.option[ id ] ;
		}
		__finally
		{
			leave() ;
		}
		return result ;
	}

	void __fastcall getPreviewPos(double *pd)
  {
		enter() ;
		try
		{
			pd[0] = m_var.option[ OPTION_PreviewPos1 ] ;
			pd[1] = m_var.option[ OPTION_PreviewPos2 ] ;
		}
		__finally
		{
			leave() ;
		}
	}

	void __fastcall getPlayableTable(bool *pb)
	{
		enter() ;
		try
		{
			for (int i=0; i < FILETYPE_COUNT; i++)
			{
				pb[i] = m_var.playable[i] ;
			}
		}
		__finally
		{
			leave() ;
		}
	}

	void __fastcall set(IFMMVAR_STRUCT *ps, const AnsiString &userDefExt)
	{
		enter() ;
		try
		{
			m_var = *ps ;
			m_userDefExt = userDefExt ;
		}
		__finally
		{
			leave() ;
		}
	}

	void __fastcall get(IFMMVAR_STRUCT *ps, AnsiString &userDefExt)
	{
		enter() ;
		try
		{
			*ps = m_var ;
			userDefExt = m_userDefExt ;
		}
		__finally
		{
			leave() ;
		}
	}

	void __fastcall getVar(IFMMVAR_STRUCT *ps)
	{
		enter() ;
		try
		{
			*ps = m_var ;
		}
		__finally
		{
			leave() ;
		}
	}

	void __fastcall setUserDefExt(const AnsiString &userDefExt)
	{
		enter() ;
		try
		{
			m_userDefExt = userDefExt ;
		}
		__finally
		{
			leave() ;
		}
	}

	AnsiString __fastcall getUserDefExt(void)
	{
		AnsiString result ;
		enter() ;
		try
		{
			result = m_userDefExt ;
			// ߂lҏWƉ̂m_userDefExtɂȂĂ܂΍
			m_userDefExt.Unique() ;
		}
		__finally
		{
			leave() ;
		}
		return result ;
	}

private:
	TCriticalSection *m_cs ;
	AnsiString m_userDefExt ;
	IFMMVAR_STRUCT m_var ;

	void __fastcall enter() { m_cs->Enter(); }
	void __fastcall leave(){ m_cs->Leave(); }

} ;
extern TPluginVar g_var ; /* O[o */


#endif /* ifmmainH */

